﻿using Syncfusion.Windows.Diagram;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _121072
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Dictionary<string,int> labelvalue=new Dictionary<string, int>(); 
        public MainWindow()
        {
            InitializeComponent();

            view.NodeDrop += view_NodeDrop;

            control.SymbolPalette.Loaded += SymbolPalette_Loaded;
        }

        void SymbolPalette_Loaded(object sender, RoutedEventArgs e)
        {
            for(int i=0;i<control.SymbolPalette.SymbolGroups.Count;i++)
            {
                SymbolPaletteGroup gr = control.SymbolPalette.SymbolGroups[i] as SymbolPaletteGroup;
            
                {
                    for (int j = 0; j < gr.Items.Count; j++)
                    {
                        SymbolPaletteItem item = gr.Items[j] as SymbolPaletteItem;
                        item.Width = 60;
                        item.Height = 60;
                        Path content = item.Content as Path;
                        item.Content = null; ;

                        Grid g = new Grid();

                        g.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(40, GridUnitType.Pixel) });
                        g.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(20, GridUnitType.Pixel) });
                        g.Children.Add(content);
                        TextBlock tb = new TextBlock();
                        string label = item.ItemName;

                        tb.Text = label.Replace("PART_", "");
                        tb.Foreground = new SolidColorBrush(Colors.Green);
                        g.Children.Add(tb);
                        Grid.SetRow(content, 0);
                        Grid.SetRow(tb, 1);
                        item.Content = g;

                    }
                }
            }
        }

        void view_NodeDrop(object sender, NodeDroppedRoutedEventArgs evtArgs)
        {
            string name=(control.SymbolPalette.SelectedItem as SymbolPaletteItem).ItemName;
            
            Node n = evtArgs.DroppedNode as Node;
            Grid g = n.Content as Grid;
            Path content = g.Children[0] as Path;
            g.Children.Clear();
            n.Content = null;
            n.Content = content;
            if (!labelvalue.ContainsKey(name))
            {
                labelvalue.Add(name, 0);
            }
            if (labelvalue.ContainsKey(name))
            {
                int value = labelvalue[name];
                labelvalue.Remove(name);

                n.Label = name + (value + 1).ToString();
                n.LabelDisplacement = new Point(n.OffsetX -(n.Width/2), n.OffsetY + n.Height);
                labelvalue.Add(name,value+1);
            }

           

        }
    }
}
